#include <stdio.h>
#include <stdlib.h>
#include<string.h>
#include "nrutil.h" 
#include <math.h>
#include "nrutil.c"
#define MAXPEOPLE 10000
#define MAXLEN 1000
#define MINMARKERS 10
void getkinshipold();
void getkinship();


 char str1[MAXLEN];
    char freqfile[MAXLEN] = "allelefreqfile";
    char ancestryfile[MAXLEN] = "admixproportionfile";
    char samplefile[MAXLEN] = "sample_include";
    char typedfile[MAXLEN]="example.tped";
char famfile[MAXLEN]="example.tfam";    
char *ch;
    int arg;
    int gfile = 0; 
    int afile = 0;
    int ffile = 0;
    int sfile = 0;
int SWITCH=0;
int pfile=0;
int K=2,NoMatrix=0;
double KINTHRESH=.025;

   int main (int argc, char *argv[])
{
  int i;
  int Kinput=0;
  int Ref=0;

 printf("\n"
           "--------------------------------------------------------------------\n"
           "|                          REAP                                    |\n"
           "|                                                                  |\n"
           "|            Relatedness Estimation in  Admixed Populatons         |\n"
           "|                                                                  |\n"
           "|               Version 1.2 - April  22th, 2013                    |\n"
           "|                                                                  |\n"
           "|                  Copyright(C) 2012, 2013                         |\n"
           "|                      Timothy Thornton                            |\n"
           "|                                                                  |\n"
           "|                         Homepage:                                |\n"
           "| http://faculty.washington.edu/tathornt/software/REAP/index.html  |\n"
           "--------------------------------------------------------------------\n\n"
);

  printf("\nThe REAP program has started \n\n");

if (argc > 1) {
	for (arg=1; arg < argc && argv[arg][0] == '-'; arg++) {
	    switch (argv[arg][1]) 
		{case 'a':
                    strncpy(ancestryfile, argv[++arg], MAXLEN);
                    printf("User specified individual ancestry file: %s\n", ancestryfile);
		    afile = 1;
		    break;
	case 'g':
		    strncpy(typedfile, argv[++arg], MAXLEN);
		    printf("User specified tped genotype file: %s\n", typedfile);
		    gfile = 1;
		    break;

case 'p':
		    strncpy(famfile, argv[++arg], MAXLEN);
		    printf("User specified family and study ID file: %s\n", famfile);
		    pfile = 1;
		    break;

	case 'f':
		    strncpy(freqfile, argv[++arg], MAXLEN);
		    printf("User specified ancestry subpopulation allele frequency file: %s\n", freqfile);
		    ffile = 1;
		    break;  
	case 's':
		    strncpy(samplefile, argv[++arg], MAXLEN);
		    printf("User specified file containing the sample individuals to include in the REAP analysis: %s\n", samplefile);
		    sfile = 1;
		    break; 
case 'r':
		      Ref = atoi( argv[++arg] );
		      if(Ref ==1 || Ref==2)
			{printf("User specified that the reference allele in the supopulation allele frequency file is: %d\n", Ref);
			  if(Ref==1)
			    {SWITCH=1;}
}
	     else
	       {printf("\nIncorrect input for the reference allele: %s\n\n", argv[++arg]);
    printf("Wrong usage. The specified reference allele must be either 1 or 2.  Use the -r command line option as follows to specify the reference allele:  ./REAP -r 1 (or 2) \n\n");
    exit(0);
	       }
		    break;

	case 'k':
             K = atoi( argv[++arg] );
	     if(K!=0)              
	       {printf("User specified that the number of ancestral subpopulations is: %d \n", K);
		 Kinput=1;}
	     else
	       {printf("\nIncorrect input for number of ancestral populations: %s\n\n", argv[++arg]);
    printf("Wrong usage. For example, to specify that threre are 3 ancestral populations, use the -k command line option as follows:  ./REAP -k 3 \n\n");
    exit(0);
	       }


 break;  




	case 't':
             KINTHRESH = atof( argv[++arg] );
	     printf("User specified minimim kinship coefficient value for a pair is %lf for the output file REAP_KinCoef_IBD.txt \n", KINTHRESH);
	      break;  
	

case 'm':
		    NoMatrix = 1;
		    printf("User specified that the Kinship Coefficient Matrix and the IBD 0 Probability Matrix will not be saved to files.\n");
		    break;


 default:
		    printf ("Unknown option \"%s\"\n", argv[arg]);
		    exit(1);

		}}

 }



if (!pfile) {
printf("The default PLINK tfam family and study ID information file will be used for the analysis: %s\n", famfile);
 }

 if (!gfile) {
printf("The default PLINK tped genotype data file will be used for the analysis : %s\n", typedfile);
 }

 if (!afile) {
printf("The default individual ancestry proprotion file will be used for the analysis: %s\n", ancestryfile);
 } 

 if (!gfile) {
printf("The default subpopulation/ancestral population allele frequency file will be used for the analysis: %s\n", freqfile);
 }


 if (!sfile) {
printf("All sample individuals will be included in the relatedness estimation analysis  \n");
 }
 

 if (!Ref) {
printf("The default reference allele of 2 will be used for the supopulation allele frequency file and the genotype data file\n");
 }
 

if (!Kinput) {
printf("The number of ancestral subpopulations in the relatedness analysis is set to the default number of %d\n", K);
 }


 getkinship();



}


void getkinship()
{


int i,j,k,l,m,n,myvalue,mycontinue,count,num,num1,num2,num3,num4,nstu;
  char mystr[200],str1[200],str2[200];
  char str3[200],str4[200],str5[200],str6[200],snpname[200];
  char chrom[200]; 
 int *admixgroup;
double *YRI,*CEU,*NAM,*ADMIXFREQ;
 double freqest,allfreq,yrifreq,ceufreq,namfreq,mexfreq;
 FILE *fstudy,*foutput,*foutputfreq, *fgeno,*fsnp,*ftped,*ftfam;
 double val0,val1,val2,val3,val4;
char line[4*(MAXPEOPLE+3)];
 int length=4*(MAXPEOPLE+3);
 int all1=0, all2=0,nloci;
 int NEWPERS1,MYCONTINUE;
 int **geno, nceu,nyri,nmex,nnam,nall;
 double *newgeno,sex,pheno;
 int *MYNUM,finalcount;
 FILE *genofile,*fdata,*fdata2,*fadmix,*fsample,*fpopfreq,*fpopfreq2,*outfile;
 double **ZMAT1;
 int **NMARKERS1;
double *INBREED1,*INBREED2;
 int *GROUP,populations;
 double **ANCESTRY;
 char **fid,**study,**newfid,**newstudy;
 int match,mynum;
 double **EIBS0,**DELTA0,**IBS0;
 double *PSQR,*QSQR,*popfreq;
 double *SQRTADMIX;
 int frappe=0;
 int Ncol, LINECOUNT,newnstu;
 double KINCOEF,IBD0,IBD1,IBD2;

 //char freqfile[MAXLEN] = "allelefreqfile";
 // char ancestryfile[MAXLEN] = "propadmixfile";
 // char samplefile[MAXLEN] = "sample_include";




if((ftfam=fopen(famfile, "r"))==NULL)
    {
	printf("Can't open %s\n",typedfile);
	exit(1);
	}





  

/* GET THE TOTAL NUMBER OF individuals in the  FILE */





 nstu=0;




fgets(line,length,ftfam);
 n=sscanf(line,"%s %s %s %s %s %s %[^\n]",str1,str2,str3,str4,str5,str6,line);
 
if(n!=6)
    {printf("There is an error in the input file %s.  The first line of the pedigree/phenotype information file does not contain exactly 6 values \n",famfile);
     exit(1);}
  else{nstu++;
    while(n==6 & fscanf(ftfam,"%s ",str1)!=EOF)
      {fgets(line,length,ftfam);
	

i=sscanf(line,"%s %s %s %s %s %[^\n]",str2,str3,str4,str5,str6,line);
	n=i+1;
	
nstu++;}

  }




 if(nstu==0)
   {printf("There is an error in the input file %s.  The first line of this file does not contain 6 values \n",famfile);
	exit(1);
   }



printf("\nThere are %d study individuals read in from the PLINK tfam family/study ID information file \n\n",nstu);


	if (nstu>MAXPEOPLE) { printf("The number of individuals in the study is greater than the maximum number of individuals allowed as specified in the REAP_SOURCE.c file. \n Change the value of MAXPEOPLE in the REAP_SOURCE.c file to a number that is larger than the size of the sample and recompile the REAP software.\n\n");
	exit(1);}
	
	


rewind(ftfam);



newfid=(char **)malloc((size_t) ((nstu+1)*sizeof(char*)));
newstudy=(char **)malloc((size_t) ((nstu+1)*sizeof(char*)));
 

 for(j=1;j<=nstu;j++)  
   {newfid[j]=(char *)malloc((size_t) ((1000)*sizeof(char)));
     newstudy[j]=(char *)malloc((size_t) ((1000)*sizeof(char)));
}
 



 count=0;

while(fscanf(ftfam,"%s %s %s %s %s %s",str1,str2,str3,str4,str5,str6)==6)
  {
count++;
i=count;
strncpy(newfid[i],str1,1000);
strncpy(newstudy[i],str2,1000);
  }


fclose(ftfam);




if((fpopfreq=fopen(freqfile,"r"))==NULL){
printf("Cannot open file.\n");
exit(1);
}


fgets(line,length,fpopfreq);

 Ncol=0; 


n=sscanf(line,"%lf %[^\n]",&val1,line);
 
  if (n<1) {	
printf("Error in subpopulation allele frequency file: There is not a single allele frequency  to read in \n"); 
	 exit(1);    
    }
  else {Ncol++;
	while (n==2)
	{
	    n=sscanf(line,"%lf %[^\n]",&val1,line);
	    if (n>=1) {
		Ncol++;
	    }
	}
    }


  printf("User specified that there are %d subpopulation/ancestral population and there are %d allele frequencies columns in the allele frequency file as expected  \n",K,Ncol);


 if(K!=Ncol)
   {
{printf("Error with either the allele frequency file  or with the number of  ancestral populations is misspecified.   There were %d allfle frequencies read from the first line of the file, however the number of ancestral populations was set to %d.  There number of allele frequencies read in for each SNP must corresond to the number of ancestral populations. \n",Ncol,K);}
 exit(1);
      }



 rewind(fpopfreq);




 populations=K;

 ANCESTRY=dmatrix(0,nstu,0,populations);

 popfreq=dvector(0,populations);

fid=(char **)malloc((size_t) ((nstu+1)*sizeof(char*)));
study=(char **)malloc((size_t) ((nstu+1)*sizeof(char*)));
 

 for(j=1;j<=nstu;j++)  
   {fid[j]=(char *)malloc((size_t) ((100)*sizeof(char)));
     study[j]=(char *)malloc((size_t) ((100)*sizeof(char)));
}
 





count=0;











sprintf(mystr,":");
// printf("mystring is %s \n",mystr);

if((fadmix=fopen(ancestryfile,"r"))==NULL){
printf("Cannot open file.\n");
exit(1);
}


 

 fscanf(fadmix,"%s %s %s ",str1,str2,str3);
 num1=strcmp(str3,mystr);

 //printf("My string is %s and the third value read in is %s, the comparison value is %d \n",mystr,str3,num1);


  if(num1==0)
    {frappe=1;
     
}

  else{frappe=0;
    }


 rewind(fadmix);


fgets(line,length,fadmix);

 Ncol=0; 




 if(frappe==1)
   { n=sscanf(line,"%s %s %s %[^\n]",str1,str2,str3,line);
     }
 else{ n=sscanf(line,"%s %s %[^\n]",str1,str2,line);}



  if (n<3) {	
printf("Error in the individual ancestry adxmiture proportion file. There is not a single individual ancestry proportion to read in \n"); 
	 exit(1);    
    }


  else {n=2;
	while (n==2)
	{
	    n=sscanf(line,"%lf %[^\n]",&val1,line);
	    if (n>=1) {
		Ncol++;
	    
		//	printf("%lf %d\n",val1,Ncol);
}
	}
    }






rewind(fadmix);




 newnstu=0;
 LINECOUNT=0;
 MYCONTINUE=1;
 
 while(MYCONTINUE==1)
    {
     
fgets(line,length,fadmix);


      

    
   
 Ncol=0; 


  if(frappe==1)
 { n=sscanf(line,"%s %s %s %[^\n]",str1,str2,str3,line);
   }
 else{ n=sscanf(line,"%s %s %[^\n]",str1,str2,line);}
 


  // printf("Here we are %s %s and n is %d\n",str1,str2,n);

if(n>=2)
  {



   if(LINECOUNT<nstu)
     {
LINECOUNT=LINECOUNT+1;
num1=strcmp(newfid[LINECOUNT],str1);
num2=strcmp(newstudy[LINECOUNT],str2);
//printf("Linecount is %d: %s %s: ",LINECOUNT,str1,str2);

if(num1!=0 || num2!=0)
  {printf("The order of individuals in the ancestry  proportion file %s must correspond to the order of the individuals in the family/study ID information file %s.  Line %d in the family information file give a family ID and individual ID of %s %s, while the individual ancestry proportion file has  a family ID and individual ID of %s %s \n",ancestryfile,famfile,LINECOUNT,newfid[LINECOUNT],newstudy[LINECOUNT],str1,str2); 
	 exit(1);   
  }
     

}

   else
     {printf("The number of individuals in the ancestry  proportion file %s must be the same as the number of individuals in the family/study ID information file %s.  There are %d individuals in the family information file, and the number of individuals given in the individual ancestry proportion file is different than this number. \n",ancestryfile,famfile,nstu);
	 exit(1);   
  }
     
  }


 if (n<3)
   {
     if (LINECOUNT<nstu) 
{	
 printf("Error in the individual ancestry adxmiture proportion file %s. There should be %d individual ancestry proportion to read based on the family/study ID information file %s, but there are only %d lines read in for this file\n",ancestryfile,nstu,famfile ,LINECOUNT); 
 	 exit(1);    
 }
   
     MYCONTINUE=0;
}
  
    
  else {n=2;
	while (n==2)
	{
	    n=sscanf(line,"%lf %[^\n]",&val1,line);
	    if (n>=1) {
		Ncol++;
		if(Ncol<=K)
		  {ANCESTRY[LINECOUNT][Ncol]=val1;
		    //		    printf("%lf ",val1);	  
  }
		else
		  {printf("Line %d in the  individual ancestry adxmiture proportion file has more than %d ancestry proportions \n",LINECOUNT,K);
		    exit(1);
		  }
		

}
	}
  
	// printf("\n");

    

if(Ncol==K)
  {newnstu++;
   MYCONTINUE=1;


}
if(Ncol!=K)
  {

if(Ncol>=1 && Ncol!=K)
  {
    printf("Line %d in the individual ancestry adxmiture proportion file has only %d ancestry proportions and there should be %d ancestry proportions for each individual based on the specified number of ancestral populations \n",LINECOUNT,Ncol,K);
		    exit(1);
  }
  
		
 else{MYCONTINUE==0;}
  }

  }

    }



if(nstu!=newnstu)
   {

     printf("The number of individuals in the ancestry  proportion file %s is must be the same as the number of individuals in the family/study ID information file %s.  There are %d individuals in the family information file, and the number of individuals given in the individual ancestry proportion file is different than this number. \n",ancestryfile,famfile,nstu,newnstu);
	 exit(1);   


   }

 

 



 fclose(fadmix);

/* 
for(i=1;i<=nstu;i++)
  {printf("%s %s: ",newfid[i],newstudy[i]);
    for(j=1;j<=K;j++) 
      {printf("%lf ",ANCESTRY[i][j]);}
    printf("\n");  
  }
*/




 /** GET THE SUBSET OF INDIVIDUALS TO CALCULATE THE RELATEDNESS ESTIMATES  **/


GROUP=ivector(0,nstu);

if(sfile==0)
  {
    GROUP[0]=nstu;
    for(i=1;i<=nstu;i++)
      {GROUP[i]=i;}
  }



if(sfile==1)
  {


    printf("Reading in the subset of individuals to include in the relatedness analysis \n");


if((fsample=fopen(samplefile,"r"))==NULL){
  printf("Cannot open file %s specifying the individuals to include in the relatedness estimaton analysis .\n",samplefile);
exit(1);
}



 GROUP[0]=0;

 /*
for(i=1;i<=nstu;i++)
  {
    match=0;  
    
 while( (fscanf(fsample,"%s %s",str1,str2)==2) &&match==0)    
   {num1=strcmp(str1,fid[i]);
     num2=strcmp(str2,study[i]);    
         if(num1==0&&num2==0)
	   {GROUP[0]=GROUP[0]+1;
	     GROUP[GROUP[0]]=i;
		 match=1;
	   }
   }

 */



while( (fscanf(fsample,"%s %s",str1,str2)==2) )    
   {
     match=0;
for(i=1;i<=nstu&&match==0;i++)
  {
   num1=strcmp(str1,newfid[i]);
     num2=strcmp(str2,newstudy[i]);    
         if(num1==0&&num2==0)
	   {GROUP[0]=GROUP[0]+1;
	     GROUP[GROUP[0]]=i;
		 match=1;
		 num3=i;

	   }

 
  }
 
//printf("%s %s and match is %d and matchnum is %d \n",str1,str2,match,num3);   

  

  

 if(match==0)
   {printf("Error: Individual with family ID  %s  and study ID %s is listed in the user specified file %s to be included in the relatedness estimation analysis, but this individual is not in the PLINK tfam file %s. Please make sure that this individual is in the input PLINK tfam file and also has genotype data in the input PLINK tped file", str1,str2,samplefile,famfile);
exit(1);       
   }

   }

 fclose(fsample);


 printf("There were %d individuals specified by the user to be included in the relatedness analysis \n",GROUP[0]);

  }



sprintf(mystr,"REAP_Individual_Index.txt");
if((foutput=fopen(mystr,"w"))==NULL){
printf("Cannot open file.\n");
exit(1);
}


fprintf(foutput," FID \t IID \t Matrix_Index\n");

for(i=1;i<=GROUP[0];i++) 
  {fprintf(foutput," %s\t %s \t %d\n",newfid[GROUP[i]],newstudy[GROUP[i]],GROUP[i]);}

    fclose(foutput);



    printf("Initializing relatedness matrices \n");


    ADMIXFREQ=dvector(0,nstu);
SQRTADMIX=dvector(0,nstu);
newgeno=dvector(0,nstu);
 
NMARKERS1=imatrix(0,nstu,0,nstu);


ZMAT1=dmatrix(0,nstu,0,nstu);

INBREED1=dvector(0,nstu);

IBS0=dmatrix(0,nstu,0,nstu);
EIBS0=dmatrix(0,nstu,0,nstu);
DELTA0=dmatrix(0,nstu,0,nstu);

 PSQR=dvector(0,nstu);
 QSQR=dvector(0,nstu);



for(i=1;i<=nstu;i++)
   {

PSQR[i]=0;
     QSQR[i]=0; 
     INBREED1[i]=-1000;
        

for(j=i;j<=nstu;j++)
       {NMARKERS1[i][j]=0;
        IBS0[i][j]=0;
	 ZMAT1[i][j]=0;
    EIBS0[i][j]=0;
DELTA0[i][j]=0;
     

       }}


 




if((fgeno=fopen(typedfile,"r"))==NULL){
printf("Cannot open file.\n");
exit(1);
}


/* GET THE TOTAL NUMBER OF PEOPLE IN A ROW */




nloci=0;
    fscanf(fgeno,"%*s %*s %*s %*s"); 
    fgets(line,length,fgeno);
    
    n=sscanf(line,"%d %d %[^\n]",&all1,&all2,line);
    if (n<2) {	
	printf("No marker to test. Please check first line in marker data file\n\n");
	exit(1);
    }
    else {
	nloci++;
	
	while (n==3)
	{
	    n=sscanf(line,"%d %d %[^\n]",&all1,&all2,line);
	    if (n>=2) {
		nloci++;
		/* printf("nloci is %d \n",nloci); */
	    }
	}
    }


    

    rewind(fgeno);

    if(nloci==nstu)
      {    printf("There are %d genotypes read in for the first SNP in the PLINK genotype data file which matches the the number of individuals in the PLINK tfam file  \n",nloci);}
if(nloci!=nstu){
printf("Number of genotypes in the tped does not match the number of study indivdiuals.\n");
exit(1);
   }

   




if((fpopfreq=fopen(freqfile,"r"))==NULL){
printf("Cannot open file.\n");
exit(1);
}







 popfreq=dvector(0,K);


 
 
Ncol=0; 
MYCONTINUE=1;
LINECOUNT=0; 
 




count=0;
 finalcount=0;
populations=K;

printf("\n\nWe are now estimating kinship coefficients and IBD sharing probabilities for all pairs of individuals  \n");
 while( (fscanf(fgeno,"%s %s %s %s",str1,str2,str3,str4)==4)  &&MYCONTINUE==1) 
   {
count++;

for(k=1;k<=nstu;k++)
{
  fscanf(fgeno,"%d %d",&all1,&all2);


  if(SWITCH==0)
    {

  if(all1==1&&all2==1)
     {newgeno[k]=0;
      }

   if( (all1==1&&all2==2)||(all1==2&&all2==1))
     {newgeno[k]=.5;}
   
if(all1==2&&all2==2)
   {newgeno[k]=1;}

    }



  if(SWITCH==1)
    {

  if(all1==1&&all2==1)
     {newgeno[k]=1;
      }

   if( (all1==1&&all2==2)||(all1==2&&all2==1))
     {newgeno[k]=.5;}
   
if(all1==2&&all2==2)
   {newgeno[k]=0;}

    }



if(all1==0||all2==0)
  {newgeno[k]=-9;}

    






 }



    Ncol=0;
 
fgets(line,length,fpopfreq);
 
LINECOUNT++;
 
      

    
   
 n=sscanf(line,"%lf %[^\n]",&val1,line);
 
 if(n==2)
   {Ncol++;
     popfreq[Ncol]=val1;

	while (n==2)
	{
	    n=sscanf(line,"%lf %[^\n]",&val1,line);
	    if (n>=1) {
		Ncol++;
popfreq[Ncol]=val1;
		if(Ncol<=K)
		  {
		    		   	  
  }
		else
		  {printf("LINE %d in the ancestral allele frequency file has more than %d ancestry allele frequencies  \n",LINECOUNT,K);
		    exit(1);
		  }
		

}
	}
  
	 

    

if(Ncol==K)
  {MYCONTINUE=1;
    
    /*
   printf("Line is %d: ",LINECOUNT);
    for(i=1;i<=K;i++)
      {printf("%lf ",popfreq[i]);

      }

    	  printf("\n");
    */
}
if(Ncol!=K)
  {

if(Ncol>=1 && Ncol!=K)
  {
    printf("Line %d in the allele frequency files has only %d ancestral allele frequencies proportions and there should be %d based on the specified number of ancestral populations \n",LINECOUNT,Ncol,K);
		    exit(1);
  }
  
		
 else{MYCONTINUE=0;}
  }

   }

 else
{MYCONTINUE=0;}


 if(count%1000==0)
      { printf("Completed marker %d \n",count);}

   

 for(l=1;l<=GROUP[0];l++)
   {i=GROUP[l];
ADMIXFREQ[i]=0;
 for(j=1;j<=populations;j++)
       {ADMIXFREQ[i]=ADMIXFREQ[i]+popfreq[j]*ANCESTRY[i][j];
}

SQRTADMIX[i]=sqrt(ADMIXFREQ[i]*(1-ADMIXFREQ[i]));

   }

 for(l=1;l<=GROUP[0];l++)
   {i=GROUP[l];
PSQR[i]=ADMIXFREQ[i]*ADMIXFREQ[i];
   QSQR[i]=(1-ADMIXFREQ[i])*(1-ADMIXFREQ[i]);
   }
  
       



for(l=1;l<=GROUP[0];l++)
  {i=GROUP[l];
    if(newgeno[i]>=0)
      {   for(m=l;m<=GROUP[0];m++)
       {

	 k=GROUP[m];
if(newgeno[k]>=0)
	   {
if(ADMIXFREQ[i]<=.99  && ADMIXFREQ[i]>=.01  && ADMIXFREQ[k]<=.99  && ADMIXFREQ[k]>=.01)
  {
 EIBS0[i][k]+=PSQR[i]*QSQR[k]+QSQR[i]*PSQR[k];


NMARKERS1[i][k]++;
  

 if( (newgeno[i]==0 && newgeno[k]==1)||(newgeno[i]==1 && newgeno[k]==0))
   {IBS0[i][k]++;}
  
       
 
 val2=((newgeno[i]-ADMIXFREQ[i])*(newgeno[k]-ADMIXFREQ[k]))/(SQRTADMIX[i]*SQRTADMIX[k]);
 
 /*
   val2=((newgeno[i]-ADMIXFREQ[i])*(newgeno[k]-ADMIXFREQ[k]))/(sqrt(ADMIXFREQ[i]*(1-ADMIXFREQ[i])) *sqrt(ADMIXFREQ[k]*(1-ADMIXFREQ[k])
));
 */


ZMAT1[i][k]+=val2;

/*
 if(l==1 && m==1  && (count%1000==0)    && count<5000 )
   {printf("%s %s: newgeno is %lf, ADMIXFREQ is %lf, val2 is %lf, and kin is %lf \n",newfid[i],newstudy[i],newgeno[i],ADMIXFREQ[i],val2,ZMAT1[i][k]/NMARKERS1[i][k]);
   }


 if(l==1 && m==3  && (count%1000==0)    && count<5000 )
   {printf("%s %s and %s %s: val2 is %lf, and kin is %lf \n",newfid[i],newstudy[i],newfid[k],newstudy[k],val2,ZMAT1[i][k]/NMARKERS1[i][k]);
   }

*/

  }

	   }

       }

      }}








 
}
 



 


 fclose(fpopfreq);
fclose(fgeno);


for(l=1;l<=GROUP[0];l++)
  {i=GROUP[l];
   for(m=l;m<=GROUP[0];m++)
     {k=GROUP[m];
DELTA0[i][k]=IBS0[i][k]/EIBS0[i][k];
DELTA0[k][i]=IBS0[i][k]/EIBS0[i][k];
 ZMAT1[i][k]/=NMARKERS1[i][k];
 ZMAT1[k][i]=ZMAT1[i][k];

     }}


 printf("\nRelatedness estimates have been calculated for all pairs of individuals \n\n");  

 
 if(NoMatrix==0)
   {
sprintf(mystr,"REAP_Kincoef_matrix.txt");
if((fdata=fopen(mystr,"w"))==NULL){
printf("Cannot open file.\n");
exit(1);
}
   


sprintf(mystr,"REAP_Inbreed.txt");
if((fdata2=fopen(mystr,"w"))==NULL){
printf("Cannot open file.\n");
exit(1);
}
 

  fprintf(fdata2,"FID \t IID \t N_SNP \t INBREEDCOEF \n");

printf("Printing the REAP Kinship Coefficient matrix to a file named REAP_Kincoef_matrix.txt \n"); 

 printf("Printing REAP Inbreeding Coefficients to a file named REAP_Inbreed.txt  \n");

/*

for(l=1;l<=GROUP[0];l++)
  {i=GROUP[l];
fprintf(fdata2,"%.6f\n",ZMAT1[i][i]);  
for(m=1;m<=GROUP[0];m++)
     {j=GROUP[m];
       if(l<m)
     {	  if(isnan(ZMAT1[i][j]))
  {fprintf(fdata,"-1000 ");}
 else
   {fprintf(fdata,"%.6f ",ZMAT1[i][j]);}
     }
	else
	  {fprintf(fdata,"NA ");}

     }
	 
	 

     

  
    fprintf(fdata,"\n");
  }
   

*/

for(l=1;l<=GROUP[0];l++)
  {i=GROUP[l];
    fprintf(fdata2,"%s \t %s \t %d \t %.6f\n",newfid[GROUP[i]],newstudy[GROUP[i]],NMARKERS1[i][i],2*ZMAT1[i][i]-1);  
   for(m=1;m<=GROUP[0];m++)
     {j=GROUP[m];
   if(isnan(ZMAT1[i][j]))
  {fprintf(fdata,"NA");}
 else
   {fprintf(fdata,"%.6f ",ZMAT1[i][j]);}
	  


	
	  
	 

     }

  
    fprintf(fdata,"\n");
  }





fclose(fdata);

 fclose(fdata2);

sprintf(mystr,"REAP_IBD0_matrix.txt");
if((fdata=fopen(mystr,"w"))==NULL){
printf("Cannot open file.\n");
exit(1);
}
 


printf("Printing the REAP IBD 0 sharing probability matrix to a file named REAP_IBD0_matrix.txt \n"); 

 

/*

for(l=1;l<=GROUP[0];l++)
  {i=GROUP[l];
   for(m=1;m<=GROUP[0];m++)
     {j=GROUP[m];
	if(l<m)
	  { if(isnan(DELTA0[i][j]))
  {fprintf(fdata,"-1000 ");}
 else
   {fprintf(fdata,"%.6f ",DELTA0[i][j]);}
	  }
	else
	  {fprintf(fdata,"NA ");}

	
	  
	 

     }

  
    fprintf(fdata,"\n");
  }
   
*/


for(l=1;l<=GROUP[0];l++)
  {i=GROUP[l];
   for(m=1;m<=GROUP[0];m++)
     {j=GROUP[m];
   if(isnan(DELTA0[i][j]))
  {fprintf(fdata,"NA");}
 else
   {fprintf(fdata,"%.6f ",DELTA0[i][j]);}
	  


	
	  
	 

     }

  
    fprintf(fdata,"\n");
  }


fclose(fdata);




  }



 if(NoMatrix==1)

   {



 

 
printf("Printing REAP Inbreeding Coefficients to a file named REAP_Inbreed.txt. User opted to not print the REAP Kinship Coefficient matrix and the REAP IBD0 matrix to files \n");


sprintf(mystr,"REAP_Inbreed.txt");
if((fdata2=fopen(mystr,"w"))==NULL){
printf("Cannot open file.\n");
exit(1);
}
 
fprintf(fdata2,"FID \t IID \t N_SNP \t INBREEDCOEF \n");


for(l=1;l<=GROUP[0];l++)
  {i=GROUP[l];
    fprintf(fdata2,"%s \t %s \t %d \t %.6f\n",newfid[GROUP[i]],newstudy[GROUP[i]],NMARKERS1[i][i],2*ZMAT1[i][i]-1);
  }

 fclose(fdata2);


   }

if((fdata=fopen("REAP_pairs_relatedness.txt", "w"))==NULL)
    {
     	printf("Can't open REAP_pairs_relatedness.txt .\n");
        exit(1);
    }

 printf("Printing relatedness estimates for pairs of individuals who have a kinship coefficient greater than or equal to  %lf to a file named REAP_pairs_relatedness.txt \n",KINTHRESH); 



fprintf(fdata,"FID1 \t IID1 \t FID2 \t IID2 \t N_SNP \t IBD0_PROB \t IBD1_PROB \t IBD2_PROB  \t KINCOEF \n");


for(l=1;l<=GROUP[0];l++)
  {i=GROUP[l];
 for(m=l+1;m<=GROUP[0];m++)
     {j=GROUP[m];
 if(ZMAT1[i][j]>=KINTHRESH&&NMARKERS1[i][j]>=MINMARKERS)
          {  
	    KINCOEF=ZMAT1[i][j];
	    IBD0=DELTA0[i][j];

	    IBD2=0;
	    IBD1=0;

  if(IBD0>1)
    {IBD0=1;}

 if(IBD0<0)
   {IBD0=0;}
 
if(IBD0!=1)
   {    

IBD2=IBD0+4*KINCOEF-1;
 
if(IBD2>1)
    {IBD2=1;}

 if(IBD2<0)
   {IBD2=0;}
	  
 if(IBD2!=1)
   {  
IBD1=1-IBD0-IBD2;

if(IBD1>1)
    {IBD1=1;}

 if(IBD1<0)
   {IBD1=0;}
   }
	  
   }


 fprintf(fdata,"%s \t %s \t %s \t %s \t %d \t  %.6f  \t %.6f \t %.6f  \t %.6f\n",newfid[i],newstudy[i],newfid[j],newstudy[j],NMARKERS1[i][j],IBD0,IBD1,IBD2,KINCOEF);}
      }

  }



fclose(fdata);

/* 




 count=0;
while(fscanf(fpopfreq,"%lg %lg %lg ",popfreq+1,popfreq+2,popfreq+3)==3 && count<5)
  {count++;
    printf("%lg %lg %lg \n",popfreq[1],popfreq[2],popfreq[3]);
  }

 
 rewind(fpopfreq);

*/





 printf("The REAP program has finished \n");






   }



/*

./REAP -g REAP_EXAMPLE_FILE_NO_RECODE.tped -p REAP_EXAMPLE_FILE_NO_RECODE.tfam -a FRAPPE_SIMULATED_SETTING2_result.txt -f FRAPPE_SIMULATED_SETTING2_freq.txt

*/


/*  gcc -O3 -o REAP REAP_SOURCE.c nrutil.c -lm  */
